// execdouble.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "execute.h"
#include "ini.h"
#include "hidewindow.h"
#include <windows.h>

//xNꂽƂɓ郁bZ[W
#define WM_EXECDOUBLE WM_APP + 1

//NX(hidewindow.hRs[)
#define WINDOW_CLASS_NAME _T("HIDE_WINDOW")

//^C}[̃CxgID
#define TIMER_EVENT_ID 1

//[h
#define MODE_EXEC_SOON 1
#define MODE_EXEC_WAIT 2

//݂̋N
int g_execCount = 0;
//ݒt@C
CIniFile *g_ini = NULL;

#define MUTEX_GUID _T("{9C3E457A-EC24-4616-8A62-05868458E6C6}")
BOOL ExistInstance(HINSTANCE hInstance)
{
	CreateMutex(NULL, TRUE, MUTEX_GUID);
	return (GetLastError() == ERROR_ALREADY_EXISTS);
}

HWND FindThisWindow(void)
{
	return FindWindow(WINDOW_CLASS_NAME, g_ini->GetIniFileName().c_str());
}

//݂̃ZNVexecs
int ExecByNowSection()
{
	WCHAR buff[256];
	_itow_s(g_execCount, buff, 256, 10);
	try {
		std::wstring exec = g_ini->GetValue(buff, _T("exec"));
		return MomoLabUtil::ShellExecute(exec);
	} catch (wchar_t*) {
		return FALSE;
	}
}

//݂̃ZNṼC^[oŃ^C}[Jn
BOOL SetTimerByNowSection(HWND hWnd)
{
	WCHAR buff[256];
	_itow_s(g_execCount, buff, 256, 10);
	int interval = g_ini->GetIntValue(buff, _T("interval"), 500);
	return SetTimer(hWnd, TIMER_EVENT_ID, interval, NULL);
}

//݂̃[h擾
int GetNowMode()
{
	WCHAR buff[256];
	_itow_s(g_execCount, buff, 256, 10);
	return g_ini->GetIntValue(buff, _T("mode"), MODE_EXEC_SOON);
}

//̃ZNV݂邩`FbN
BOOL IsNextSection()
{
	WCHAR buff[256];
	_itow_s(g_execCount + 1, buff, 256, 10);
	try {
		g_ini->GetValues(buff);
		return TRUE;
	} catch (wchar_t*) {
		return FALSE;
	}
}

HRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
		case WM_CREATE:
			//AvP[VN郁bZ[W𓊂
			SendMessage(hWnd, WM_EXECDOUBLE, 0, 0);
			break;

		case WM_TIMER:
			//^C}[~߂
			KillTimer(hWnd, TIMER_EVENT_ID);

			//mode=2ȂexecN
			if (GetNowMode() == MODE_EXEC_WAIT) {
				ExecByNowSection();
			}

			//Ԃ̂ŏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);

			break;

		case WM_EXECDOUBLE:
			//^C}[x~߂
			KillTimer(hWnd, TIMER_EVENT_ID);

			//N񐔂񑝂₷
			g_execCount++;

			//̃ZNVȂ΁AexecsďI
			if (!IsNextSection()) {
				ExecByNowSection();
				SendMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			}

			//mode=1Ȃexecs
			if (GetNowMode() == MODE_EXEC_SOON) {
				ExecByNowSection();
			}

			//^C}[Jn
			SetTimerByNowSection(hWnd);

			break;

		case WM_DESTROY:
            PostQuitMessage(0);
            break;

		default:
            return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }
    return 0;
}

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	//init@CNX𐶐
	if (wcslen(lpCmdLine) > 0) {
		g_ini = new CIniFile(lpCmdLine, FALSE);
	} else {
		g_ini = new CIniFile(hInstance, FALSE);
	}

	//dN`FbN
	if (ExistInstance(hInstance)) {
		//łɋNĂꍇ͂̃EBhETAbZ[W𓊂B
		HWND hWnd = FindThisWindow();
		if (hWnd) {
			SendMessage(hWnd, WM_EXECDOUBLE, 0, 0);
		}
		return 0;
	}

	//init@C[hB
	g_ini->Load();
	if (g_ini->Fail()) {
		MessageBox(0, _T("ݒt@C܂B"), _T("mF"), MB_OK);
		return 1;
	}

	//EBhE쐬
	CHideWindow window(hInstance);
	if (window.Create(WndProc, g_ini->GetIniFileName().c_str())) {
		return window.Run();
	}

	return 1;
}
